/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */

#ifndef _JS_NATIVE_ARRAY_H_
#define _JS_NATIVE_ARRAY_H_

#include "js-scriptableobject.h"

/* Classes */
class JSNativeArray: public JSScriptableObject {
    friend class JSContext;

    protected:
        static  const int maximumDenseLength = 10000;

        int64_t         length;
        jsVal_t         *dense;
        int             denseLength;
        uint32_t        *denseBits;

    public:
        static  const jsString_t        className;

    protected:
        static  void    finishInit(JSContext *cx, JSScriptable *scope,
                                JSFunctionObject *ctor,
                                JSScriptable *proto);

        /* JS methods */
        static  jsVal_t jsConstructor(JSContext *cx, int numArgs,
                                jsVal_t *args, JSFunction *ctorObj,
                                jsBool_t inNewExpr);
        static  jsVal_t jsFunction_toString(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_join(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_reverse(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_sort(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_push(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_pop(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_shift(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_unshift(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_splice(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_concat(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t jsFunction_slice(JSContext *cx,
                                JSScriptable *thisObj, int numArgs,
                                jsVal_t *args, JSFunction *funObj);
        static  jsVal_t toStringHelper(JSContext *cx, JSScriptable *thisObj,
                                jsBool_t toSource);
        static  double  getLengthProperty(JSContext *cx, JSScriptable *obj);
        static  jsBool_t
                        hasLengthProperty(JSContext *cx, jsVal_t val);
        static  jsBool_t
                        hasElem(JSContext *cx, JSScriptable *target,
                                int64_t index);
        static  jsVal_t getElem(JSContext *cx, JSScriptable *target,
                                int64_t index);
        static  void    setElem(JSContext *cx, JSScriptable *target,
                                int64_t index, jsVal_t value);
        static  double  qsortCompare(JSContext *cx, jsVal_t jsCompare,
                                jsVal_t x, jsVal_t y, JSScriptable *scope);
        static  void    qsort(JSContext *cx, jsVal_t jsCompare,
                                jsVal_t *working, int lo, int hi,
                                JSScriptable *scope);
        static  void    qsort_extended(JSContext *cx, jsVal_t jsCompare,
                                JSScriptable *target, int64_t lo, int64_t hi);
        static  jsBool_t
                        denseIsSet(int index, uint32_t *denseBits);
        static  void    denseClr(int index, uint32_t *denseBits);
        static  void    denseSet(int index, uint32_t *denseBits);

    public:
        static  void    defineClass(JSContext *cx, JSScriptable *scope);

        JSNativeArray(JSContext *cx, jsVal_t *array, int arrayLength);
        JSNativeArray(JSContext *cx, int64_t length);
        JSNativeArray();

        jsBool_t
                jsGet_length(JSContext *cx, jsVal_t *val);
        void    jsSet_length(JSContext *cx, jsVal_t val);

        /* instanceof methods */
        jsBool_t
                isInstanceOf(const jsString_t className);

        /* scriptable methods */
        jsString_t
                getClassName(JSContext *cx);
        jsBool_t
                get(JSContext *cx, int index, JSScriptable *start,
                        jsVal_t *value);
        jsBool_t
                has(JSContext *cx, int index, JSScriptable *start);
        void    put(JSContext *cx, jsString_t id, JSScriptable *start,
                        jsVal_t value);
        void    put(JSContext *cx, int index, JSScriptable *start,
                        jsVal_t value);
        void    del(JSContext *cx, int index);
        jsVal_t *
                getIds(JSContext *cx, int *numIds);
        jsVal_t getDefaultValue(JSContext *cx, jsType_t typeHint);

        /* gc methods */
        void    mark(JSContext *cx);
} ;

#endif /* _JS_NATIVE_ARRAY_H_ */

